/* Disper Displays Extension
 * author: mark bokil
 * 8/25/12
 * version 1.1.1
 * some code also by Panel Commands by Denoyse <denoyse@gmail.com>.
 * Thanks to gcampax (https://extensions.gnome.org/accounts/profile/gcampax) for most of the code ;-)
 */


const GLib = imports.gi.GLib;
const Main = imports.ui.main;
const PanelMenu = imports.ui.panelMenu;
const PopupMenu = imports.ui.popupMenu;
const Gettext = imports.gettext.domain('gnome-shell-extensions');
const _ = Gettext.gettext;

function Indicator() {
    this._init.apply(this, arguments);
}

Indicator.prototype = {
    __proto__: PanelMenu.SystemStatusButton.prototype,

    _init: function() {
        PanelMenu.SystemStatusButton.prototype._init.call(this, 'video-display-symbolic'); 
        this._createMenu();
        this._createSubMenu();
    },

    _createMenu: function() {
        this._addCommand("Primary Display", "disper --single",this.menu);
        this._addCommand("Secondary Display", "disper --secondary",this.menu);
        this._addCommand("Clone Displays", "disper --clone", this.menu);
    },

    _createSubMenu: function() {
        this.extendMenu = new PopupMenu.PopupSubMenuMenuItem(_("Extend Displays")); 
        
        this._addCommand("Left", "disper --extend --direction=left",this.extendMenu.menu);
        this._addCommand("Right", "disper --extend --direction=right",this.extendMenu.menu);
        this._addCommand("Top", "disper --extend --direction=top",this.extendMenu.menu);
        this._addCommand("Bottom", "disper --extend --direction=bottom",this.extendMenu.menu);        
        this.menu.addMenuItem(this.extendMenu);     
    },


    _addSeparator: function() {
    	this.menu.addMenuItem(new PopupMenu.PopupSeparatorMenuItem());
    },

    _addCommand: function(label, command, menu) {
    	menu.addAction(_(label), function() { 
            try {
                GLib.spawn_command_line_async(command);
            } catch(e) {
                Main.notify('This extension requires Disper to be installed.');
            }
        });
    },
}


function init() {}

let _indicator;

function enable() {
    _indicator = new Indicator();
    Main.panel.addToStatusArea('display', _indicator);
}

function disable() {
    _indicator.destroy();
}
